import greenfoot.*;

public class Space extends World
{
    Row[] rows = new Row[8];
    int timer, direction, level = 1;
    boolean drop;

    public Space()
    {
        super(450, 500, 1);
        prepare();
    }
    
    private void prepare()
    {
        removeObjects(getObjects(null));
        for (int j=0; j<3+level; j++)
        {
            rows[j] = new Row();
            addObject(rows[j], 225, 25+j*50);
            for (int i=0; i<8; i++) addObject(new Invader(), 50+i*50, 25+j*50);
        }
        addObject(new Player(), 30, 475);
        timer = 0;
        direction = 1;
        drop = false;
    }
    
    public void act()
    {
        if (timer == 0 && drop)
        {
            for (int i=0; i<3+level; i++)
            {
                rows[i].dropRow();
                drop = false;
            }
            direction = -direction;
        }
        if (timer%3 == 0 && timer < 3*(3+level)) drop = rows[timer/3].moveRow(direction) || drop;
        timer = (timer+1)%32;
        if (getObjects(Invader.class).isEmpty())
        {
            if (level < 5) level++;
            prepare();
        }
        if (getObjects(Player.class).isEmpty()) prepare();
    }
}