import greenfoot.*;

public class Bullet extends Actor
{
    public Bullet()
    {
        GreenfootImage image = new GreenfootImage(12, 3);
        image.fill();
        setImage(image);
    }

    public void act()
    {
        move(4);
        World world = getWorld();
        if (getRotation() == 270)
        {
            Actor invader = getOneIntersectingObject(Invader.class);
            if (invader != null)
            {
                world.removeObject(invader);
                world.removeObject(this);
            }
            else if (getY() == 0) world.removeObject(this);
        }
        else
        {
            Actor player = getOneIntersectingObject(Player.class);
            if (player != null)
            {
                world.removeObject(player);
                world.removeObject(this);
            }
            else if (getY() == world.getHeight()-1) world.removeObject(this);
        }
    }
}