import greenfoot.*;

public class Player extends Actor
{
    int shotTimer;
    
    public Player()
    {
        GreenfootImage image = new GreenfootImage(29, 15);
        int[] xs = {  0,  3, 12, 14, 16, 25, 28 };
        int[] ys = { 14,  4,  4,  0,  4,  4, 14 };
        image.fillPolygon(xs, ys, 7);
        setImage(image);
    }

    public void act()
    {
        runShotTimer();
        int dx = 0;
        if (Greenfoot.isKeyDown("left")) dx--;
        if (Greenfoot.isKeyDown("right")) dx++;
        if (dx == 0 || getX()+dx < 15 || getX()+dx > getWorld().getWidth()-16) return;
        move(dx);
    }
    
    private void runShotTimer()
    {
        if (shotTimer > 0) shotTimer--;
        if (shotTimer > 0) return;
        if (Greenfoot.isKeyDown("up"))
        {
            Bullet bullet = new Bullet();
            bullet.setRotation(270);
            getWorld().addObject(bullet, getX(), getY());
            bullet.move(10);
            shotTimer = 20;
        }
    }
}