import greenfoot.*;

public class Row extends Actor
{
    public Row()
    {
        setImage(new GreenfootImage(450, 1));
    }
    
    public boolean moveRow(int dir)
    {
        boolean changeDir = false;
        for (Object obj : getIntersectingObjects(Invader.class))
        {
            Invader invader = (Invader) obj;
            changeDir = invader.moveInvader(dir) || changeDir;
        }
        return changeDir;
    }
    
    public void dropRow()
    {
        for (Object obj : getIntersectingObjects(Invader.class))
        {
            Actor invader = (Invader) obj;
            invader.setLocation(invader.getX(), invader.getY()+10);
        }
        setLocation(getX(), getY()+10);
    }
}